## The name of the Animal has to be changed a Tick after it is Summoned because of something i think is a Bug
execute as @e[tag=needs_name, type=chicken] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:chicken name
execute as @e[tag=needs_name, type=cow] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:cow name
execute as @e[tag=needs_name, type=mooshroom] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:mooshroom name
execute as @e[tag=needs_name, type=pig] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:pig name
execute as @e[tag=needs_name, type=rabbit] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:rabbit name
execute as @e[tag=needs_name, type=sheep] on controller unless data entity @s CustomName run data modify entity @s CustomName set from storage hopassive:sheep name
execute as @e[tag=needs_name] run data modify entity @s Tags set value ["hostile_animal"]


## Convert Animals to their Hostile Counterpart
execute as @e[tag=!hostile_animal, tag=!cured, type=chicken] at @s run function hopassive:convert_evil with storage hopassive:chicken
execute as @e[tag=!hostile_animal, tag=!cured, type=cow] at @s run function hopassive:convert_evil with storage hopassive:cow
execute as @e[tag=!hostile_animal, tag=!cured, type=mooshroom] at @s run function hopassive:convert_evil with storage hopassive:mooshroom
execute as @e[tag=!hostile_animal, tag=!cured, type=pig] at @s run function hopassive:convert_evil with storage hopassive:pig
execute as @e[tag=!hostile_animal, tag=!cured, type=rabbit] at @s run function hopassive:convert_evil with storage hopassive:rabbit
execute as @e[tag=!hostile_animal, tag=!cured, type=sheep] at @s run function hopassive:convert_evil with storage hopassive:sheep

## Kill the AI overrides when they arent riding Hostile Animals
execute as @e[tag=hostile_brain, predicate=!hopassive:riding_animal] run ride @s dismount
execute as @e[tag=hostile_brain, predicate=!hopassive:riding_animal] run tp 0 -1000 0

## If player uses the cure food on Animal, find the Animal that has just been fed and cure it
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=chicken] run function hopassive:convert_cure {"entity":"chicken"}
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=cow] run function hopassive:convert_cure {"entity":"cow"}
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=mooshroom] run function hopassive:convert_cure {"entity":"mooshroom"}
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=pig] run function hopassive:convert_cure {"entity":"pig"}
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=rabbit] run function hopassive:convert_cure {"entity":"rabbit"}
execute at @a[advancements={hopassive:used_cure_item=true}] as @e[sort=nearest, limit=1, nbt={InLove:600}] if entity @s[type=sheep] run function hopassive:convert_cure {"entity":"sheep"}
advancement revoke @a only hopassive:used_cure_item